# créé par uncledens , http://uncledens.chez-alice.fr/

fichier='ACT_0001' #nom du fichier (sans l'extention .OMD)
champ=["lat0","lat1","lat2","lat3","lon0","lon1","lon2","lon3","dist0","dist1","dist2","dist3","tps0","tps1","inconnu","alt0","alt1","inconnu","inconnu","F1",
       "lat0","lat1","lat2","lat3","lon0","lon1","lon2","lon3","dist0","dist1","dist2","dist3","tps0","tps1","inconnu","alt0","alt1","inconnu","inconnu","F1",
       "tps0","tps1","vit0","vit1","KCal0","KCal1","coeur","inconnu","inconnu","moitieF2","tps0","tps1","vit0","vit1","KCal0","KCal1","coeur","inconnu","inconnu","F2"]
result=["Temps(s)","Cardio(ppm)","Distance(m)","Vitesse(km/h)","Latitude(°)","Longitude(°)","Altitude(m)"]
nbresult=len(result)
sep="\t" #separateur \t = tabulation

txt=""
for i in range(60):
    txt+=champ[i]+sep
txt+="\n"

txtresult=""
for i in range(nbresult):
    txtresult+=result[i]+sep
txtresult+="\n"
    
       
cpt=0
premiereligne=1
with open(fichier+'.OMD', 'rb') as file: #OMD et OMH 1, 2, 5, 40
    for c in file:
        for i in c:
            octet=str(i)
            col=cpt%60

            
            if col==0:
                txt+="\n"
                
                if premiereligne==1:
                    premiereligne=0
                else:# calcule toutes les variables et intégre dans txtresult
                    #calcul du temps
                    tps1=str(champ[13]*256+champ[12])
                    tps2=str(champ[33]*256+champ[32])
                    #Cardio
                    card1=str(champ[46])
                    card2=str(champ[56])
                    #distance(m)
                    dist1=str(champ[11]*256**3+champ[10]*256**2+champ[9]*256+champ[8])
                    dist2=str(champ[31]*256**3+champ[30]*256**2+champ[29]*256+champ[28])
                    #vitesse instantanée
                    vit1=str((champ[43]*256+champ[42])/100)
                    vit2=str((champ[53]*256+champ[52])/100)
                    #longitude
                    lon1=str((champ[7]*256**3+champ[6]*256**2+champ[5]*256+champ[4])/1000000)
                    lon2=str((champ[27]*256**3+champ[26]*256**2+champ[25]*256+champ[24])/1000000)
                    #latitude
                    lat1=str((champ[3]*256**3+champ[2]*256**2+champ[1]*256+champ[0])/1000000)
                    lat2=str((champ[23]*256**3+champ[22]*256**2+champ[21]*256+champ[20])/1000000)
                    #altitude
                    alt1=str(champ[16]*256+champ[15])
                    alt2=str(champ[36]*256+champ[35])

                    txtresult+=(tps1+sep+card1+sep+dist1+sep+vit1+sep+lat1+sep+lon1+sep+alt1+"\n").replace(".",",")
                    txtresult+=(tps2+sep+card2+sep+dist2+sep+vit2+sep+lat2+sep+lon2+sep+alt2+"\n").replace(".",",")                
            else:
                txt+="\t"
             
            if i<10:
                txt+="00"
            elif i<100:
                txt+="0"
            txt+=octet
            champ[col]=int(octet)
            cpt+=1


destinationsave = open(fichier+'DATA0.txt', "w")# traduction des valeurs hexadecimales brutes en valeurs décimales, exportées sous forme de tableau
destinationsave.write(txt)
destinationsave.close()
destinationsave = open(fichier+'DATA1.txt', "w")# export des données calculées depuis les valeurs brutes du précédent tableau
destinationsave.write(txtresult)
destinationsave.close()
